/*------------------------------------------------*/
/* c07dynamic/main.c                              */

#include <stdio.h>
#include <dlfcn.h>


int main(int argc, char **argv) {
	char *cesta_ke_knihovne, *nazev_funkce;
	char *error;
	void *lib;
	void (*funkce)() = NULL;

	if(argc != 3) {
		fprintf(stderr,"Usage: %s knihovna.so nazev_funkce\n", argv[0]);
		return 1;
	}

	cesta_ke_knihovne = argv[1];
	nazev_funkce = argv[2];

	printf("Oteviram knihovu '%s'\n", cesta_ke_knihovne);

	lib = dlopen(cesta_ke_knihovne, RTLD_LAZY);
	if(lib == NULL) {
		fprintf(stderr, "%s\n", dlerror());
		return 1;
	}

	printf("Nacitam funkci '%s\n", nazev_funkce);
	(void) dlerror(); /* vycisteni chyb */
	funkce =  dlsym(lib, nazev_funkce);
	error = dlerror();
	if(error != NULL) {
		fprintf(stderr, "%s\n", error);
		return 1;
	}

	/* spusteni funke */
	(*funkce)();

	/* zavreni knihovny, uvolneni zdroju */
	dlclose(lib);
	return 0;
}
/*------------------------------------------------*/
