#include <memory.h>
#include "../gdbm.h"
#include "../curses.h"
#include "../struktury_dbm.h"
#include "../lib_dbm.h"

#define HORN 4

void
trideni_semestr (DBM * dbm_ptr)
{
  struct zaznam nacteno;
  struct dbm_info informace;
  WINDOW *pad;
  datum klic;
  datum data;
  int klavesa, i;
  int ukazatel;

  informace = zjisti_informace (dbm_ptr);

  pad = newpad (informace.poc_zaznamu + SEMESTRU * 3, COLS);
  erase ();
  printw ("Čekejte ...");
  refresh ();

  for (i = 1; i <= SEMESTRU; i++)
    {
      if(!informace.predmetu[i][0])
        continue;
      wattron(pad,COLOR_PAIR(3));
      wprintw (pad, "\nSEMESTR %i\n", i);
      wprintw (pad, "%-*s\n", COLS - 1, "-----------------------------");
      wattroff(pad,COLOR_PAIR(3));

      for (klic = dbm_firstkey (dbm_ptr); klic.dptr;
            klic = dbm_nextkey (dbm_ptr))
      {
          data = dbm_fetch (dbm_ptr, klic);
          memcpy (&nacteno, data.dptr, data.dsize);
    
          if (nacteno.semestr == i)
          {
              if (!nacteno.vsemestru)
                 wattron (pad, A_BOLD);
              wprintw8 (pad, L"%4s %-40s %6i %6i ",
                   nacteno.kod, nacteno.nazev,
                   nacteno.vsemestru, nacteno.kreditu);
              if (nacteno.znamka)
                 wprintw8 (pad, L"%6i", nacteno.znamka);
              else
                 wprintw8 (pad, L"%6s", "-");
              waddch (pad, '\n');
              if (!nacteno.vsemestru)
                 wattroff (pad, A_BOLD);
          }
      }
    }

  erase ();
  mvprintw (0, 0, "BACKSPACE nebo F10 = konec;");
  mvprintw (1, 0, "%i zaznamu.\n", informace.poc_zaznamu);
  mvprintw8 (2, 0, L"%4s %-40s %6s %6s %6s", "kód:", "Název",
        "v sem.", "kredit", "známka");
  refresh ();


  ukazatel = 0;
  i = informace.poc_zaznamu + SEMESTRU * 3 - (LINES - 1 - HORN);
  do
    {
      prefresh (pad, ukazatel, 0, HORN, 0, LINES - 1, COLS - 1);
      klavesa = getch ();
      switch (klavesa)
    {
    case ' ':
    case KEY_DOWN:
      if (ukazatel < i - 1)
        ukazatel++;
      break;
    case KEY_UP:
      if (ukazatel > 0)
        ukazatel--;
      break;
    default:
      break;
    }
    }
  while (klavesa != KEY_BACKSPACE  && klavesa != KEY_F(10));

  delwin (pad);
}
