/*------------------------------------------------*/
/* 20zakladyI/flock.c                             */

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <errno.h>
#include <unistd.h>
#include <sys/file.h>

int flock(int fd, int operation);


int main(int argc, char *argv[]) {
	bool write = false;
	int opt;
	char *filename = NULL;
	do {
		opt = getopt(argc, argv, "+wf:");
		switch(opt) {
			case -1: break;
			case '?':
			case ':':
				exit(1);
			case 'w': write = true; break;
			case 'f': filename = optarg; break;
			
		}
	} while (opt != -1);

	if(!filename) {
		fprintf(stderr,"Zadejte jméno souboru pomocí volby -f \"jmeno souboru\"\n");
		exit(1);
	}	
	printf("Otevírám soubor %s pro %s\n", filename, write ? "zápis" : "čtení");
	FILE* f = fopen(filename,         write ? "w"   : "r");
	if(f == NULL) {
		fprintf(stderr, "Soubor %s neexistuje.\n", filename);
		exit(1);
	}
	printf("Získávám zámek pro %s\n", write ? "zápis" : "čtení");
	int result = flock(fileno(f),     write ? LOCK_EX : LOCK_SH);
	if(result) {
		perror(NULL);
		exit(1);
	}

	printf("Čekám na stisk ENTERu ");
	(void) getchar();

	printf("Uvolňuji zámek a zavírám soubor\n");
	flock(fileno(f), LOCK_UN);
	fclose(f); /* taky by uvolnil zamek */
	
	return 0;
}
