/*------------------------------------------------*/
/* 20zakladyI/getoptlong.c                        */

#include <unistd.h>
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h> /* atoi() */
#include "options.h"
#include <locale.h>


int main (int argc, char * argv[]) {
	int op,i;
	struct options Option = { 0, false, NULL, false, 0};
	char  *optstring = "+shf:m::";
 	const struct option longopts[] = {
    		{ "speed",	no_argument,	   NULL, 'S' },
    		{ "help",	no_argument,	   NULL, 'H' },
    		{ "file",	required_argument, NULL, 'F' },
    		{ "messages",	optional_argument, NULL, 'M' },
    		{ NULL,		no_argument,	   NULL,  0  }
  	};

	//setlocale(LC_MESSAGES, "");

	do {
		op = getopt_long(argc, argv, optstring, longopts, NULL);

		switch(op) {
			case -1:  break;
			case '?': fprintf(stderr,"Unknown or invalid argument for %c\n",optopt); return 1;
			case ':': fprintf(stderr,"Missing argument for :\n"); return 2;
			case 'H':
			case 'h': Option.help = true; break;
			case 'S':
			case 's': Option.speed++; break;
			case 'F':
			case 'f': Option.file = optarg; break;
			case 'M':
			case 'm':
				 Option.messagesEnabled = true;
				 if(optarg != NULL) {
					printf("optarg je %s\n", optarg);
				 	Option.messageLevel = atoi(optarg);
				 }
				 break;
		}
	
	} while(op != -1);

	printOption(Option);

	for(i = optind; i < argc; i++) {
		printf("\t\t-- %s\n", argv[i]);
	}

	return 0;
}
/*------------------------------------------------*/
