#include <sys/time.h>
#include <sys/resource.h>
#include <errno.h>
#include "setstack.h"

void setStack(const rlim_t kStackSize) {
    	struct rlimit rl;
    	int result;

    	result = getrlimit(RLIMIT_STACK, &rl);
    	printf("current stack limit = %.2f MiB\n", (double) rl.rlim_cur/(1024*1024));
    	if (result != 0) {
		perror(NULL);
		abort();
	}
	printf("set stack limit to %.2f MiB\n", (double) kStackSize/(1024*1024));
	rl.rlim_cur = kStackSize;
        result = setrlimit(RLIMIT_STACK, &rl);
        if (result != 0)
        {
		fprintf(stderr, "setrlimit returned result = %d\n", result);
		abort();
        }
}


