/*------------------------------------------------*/
/* 22process/spawn.c                              */

#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h> /* abort */
#include <stdio.h>
#include <stdbool.h>

#define MUDRC "./mudrc"

pid_t spustProgram() {
    pid_t fpid;
    fpid = fork();
    
    if(fpid == -1) {
        perror(NULL);
         abort();
    }
    else if(fpid == 0) {
        /* child process */
        printf("dítě: Moje id = %d\n", getpid());
        printf("dítě: Rodičovské id = %d\n", getppid());
        /* execl ukonci proces */
        execl(MUDRC, MUDRC,"Hello", "World", (char *)NULL);
        perror("Program mudrc se nepodařilo spustit\n");
    }
    return fpid;
}

int main(void) {
    pid_t pid;
    
    printf("rodič: moje id = %d\n", getpid());
    pid = spustProgram();
    printf("rodič: Číslo %d žije!\n", getpid());
    printf("rodič: Id potomka = %d.\n", pid);

#if defined WAIT_ON_CHILD
    int stat_loc;
    if(pid > 0) {
        waitpid(pid, &stat_loc, 0);
        if(WIFEXITED(stat_loc)) { 
            printf("rodič: Dítě volalo exit(%i)\n",
                 WEXITSTATUS(stat_loc));
        } else if(WIFSIGNALED(stat_loc)) {
            printf("rodič: Dítě dostalo signál %d\n",
                 WTERMSIG(stat_loc));
        }
    }
#elif defined ZOMBIE
    int sec = 30;
    printf("rodič: Spím %d sekund.", sec);
    fflush(stdout);
    while(sec--) {
        fflush(stdout);
        printf("\rrodič: Spím na %d sekund.", sec);
        sleep(1);
    }
    printf("\n");
#endif
    return 0;
}

/*------------------------------------------------*/
