/*------------------------------------------------*/
/* 24threads/podminky.c                           */

#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdio.h>
#include <string.h>

#define N 1024*1024

typedef struct {
    pthread_mutex_t * mutex;
    int * m;
} sdilenaPamet;

bool zapsano = false;
pthread_cond_t cond;

void * producent(void * arg) {
    int i,j;
    sdilenaPamet *p = (sdilenaPamet *) arg;
    srand(0);
    printf("Producent start\n");
    for (i = 0; i <= 10; i++) { 
        pthread_mutex_lock(p->mutex);
        while(zapsano) {
            pthread_cond_wait(&cond, p->mutex);
        }
        for (j = 0; j < N; j++) {
            memcpy(p->m+j, &i, sizeof(int));
        }
        zapsano = true;
        pthread_cond_signal(&cond);
        pthread_mutex_unlock(p->mutex);
        usleep(rand() %50);
    }
    printf("Producent konec\n");
    return NULL;
}

void * consumer(void * arg) {
    static int result = 0;
    sdilenaPamet *p = (sdilenaPamet *) arg;
    int i;
    for (i = 0; i <= 10; i++) {
        pthread_mutex_lock(p->mutex);
        while(!zapsano) {
            pthread_cond_wait(&cond, p->mutex);
        }
        printf("m = %i ... %i", *(p->m), *(p->m+(N-1)));
        result += *(p->m);
        zapsano = false;
        pthread_cond_signal(&cond);
        pthread_mutex_unlock(p->mutex);
        usleep(100000);
        printf("\n");
    }
    return &result;
}

int main(void) {
    pthread_t producent_t, consumer_t;
    pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
    int m[N];
    sdilenaPamet pamet = {&mutex,m};
    int *result;

    pthread_cond_init(&cond,NULL);

    pthread_create(&producent_t,NULL,producent,(void *)&pamet);
    pthread_create(&consumer_t,NULL,consumer,(void *)&pamet);

    pthread_join(producent_t, NULL);
    pthread_join(consumer_t, (void **)&result);
    pthread_cond_destroy(&cond);
    pthread_mutex_destroy(&mutex);
    printf("main konec, result = %i\n", *result);

    return 0;
}

/*------------------------------------------------*/
