/*------------------------------------------------*/
/* 25daemon/signals.c                             */
#include <stdio.h>
#include <signal.h>
#include "signals.h"

static int *r;
static int *s;

static void sigterm_handler(int sig)
{
    *r = 0;
}

static void sighup_handler(int sig)
{
    *s = 1;
}

void setSignalHandlers(int *running, int *sighup)
{
    struct sigaction sa;
    sigset_t set;

    r = running;
    s = sighup;

    signal(SIGTERM, sigterm_handler);

    sigemptyset(&set);
    sa.sa_handler = sighup_handler;
    sa.sa_mask = set;
    sa.sa_flags = SA_RESTART;
    sa.sa_restorer = NULL;
    sigaction(SIGHUP, &sa, NULL);
}

/*------------------------------------------------*/
