/*------------------------------------------------*/
/* 27aDom/dom-utils.c                             */

#include <stdbool.h>
#include <string.h>
#include "dom-utils.h"

void copyXMLString(xmlDocPtr doc, xmlNodePtr cur, char *dest, size_t destLength)
{
    xmlChar *string;
    string = xmlNodeListGetString(doc, cur->xmlChildrenNode, 1);
    if (string != NULL) {
        strncpy(dest, (char *)string, destLength);
        dest[destLength - 1] = '\0';    // pro jistotu
        xmlFree(string);
    }
}

/**
* Pozn: funkce atoi() nedetekuje chyby.
* Lepsi by bylo pouzit strtol()
*/
void copyXMLInteger(xmlDocPtr doc, xmlNodePtr cur, int *dest)
{
    xmlChar *string;
    string = xmlNodeListGetString(doc, cur->xmlChildrenNode, 1);
    if (string != NULL) {
        *dest = atoi((char *)string);
        xmlFree(string);
    }
}

bool getProperty(xmlNodePtr cur, char *name, char *dest, size_t destLength)
{
    xmlChar *value;
    value = xmlGetProp(cur, (xmlChar *) name);
    if (value == NULL)
        return false;
    strncpy(dest, (char *)value, destLength);
    dest[destLength - 1] = '\0';    // pro jistotu
    xmlFree(value);
    return true;
}

/*------------------------------------------------*/
