/*------------------------------------------------*/
/* 27bSax/sax-parser.h                            */

#ifndef _SAX_PARSER
#define _SAX_PARSER

#include <libxml/parser.h>
#include "config.h"
#include "stdbool.h"

typedef struct {
    Config *config;
    const xmlChar *sx_namespace;
    xmlChar *text;
    bool unknown;
    int unknownDepth;
    bool sx_config;
    bool version;
    bool version_major;
    bool version_minor;
    bool databases;
    bool database;
    int databaseNum;
    bool database_name;
    bool database_password;
    bool database_schema;
    bool database_host;
    bool database_port;
} UserData;

void startDocument(void *user_data);
void endDocument(void *user_data);
void startElementNs(void *ctx,
        const xmlChar * localname,
        const xmlChar * prefix,
        const xmlChar * URI,
        int nb_namespaces,
        const xmlChar ** namespaces,
        int nb_attributes,
        int nb_defaulted, const xmlChar ** attributes);
void endElementNs(void *ctx,
        const xmlChar * localname,
        const xmlChar * prefix, const xmlChar * URI);
void characters(void *user_data, const xmlChar * ch, int len);
#endif

/*------------------------------------------------*/
