<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="/">
        <html>
            <head>
                <title>Adresář</title>
                <style type="text/css">
                     table {
                        border-collapse:collapse;
                     }
                     th,td {
                        padding:3px 5px;
                        text-align:left;
                     }
                     th {
                        border-bottom:3px solid black;
                     }
                </style>
            </head>
            <body>
                <h1>Adresář</h1>
                <xsl:apply-templates/>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="adresare">
        <table border="1">
        <tr style="background:#00aaff;color:#ffffff;">
            <th>Jméno</th><th>Příjmení</th>
            <th>Ulice</th><th>ČP</th><th>Město</th><th>PSČ</th>
            <th>Telefon*</th>
        </tr>
            <xsl:apply-templates select="Adresar">
            <xsl:sort select="city" />
            <xsl:sort select="firstName" order="descending" />
            </xsl:apply-templates>
        </table>
        <em>*Povinná položka</em>
    </xsl:template>

    <xsl:template match="Adresar">
        <xsl:if test="starts-with(city,'Praha')">
            <tr bgcolor="#00fa00">
                <xsl:for-each select="*">
                    <td><xsl:value-of select="." /></td>
                </xsl:for-each>
            </tr>
        </xsl:if>
        <xsl:if test="not(starts-with(city,'Praha'))">
            <tr>
                <xsl:apply-templates/>
            </tr>
        </xsl:if>
    </xsl:template>

    <xsl:template match="phone">
        <xsl:choose>
            <xsl:when test=". = ''">
                <td bgcolor="red"><xsl:value-of select="." /></td>
            </xsl:when>
            <xsl:otherwise>
                <td><xsl:value-of select="."/></td>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="*">
        <td><xsl:value-of select="."/></td>
    </xsl:template>

</xsl:stylesheet>