/*------------------------------------------------*/
/* 29postgresql/insert.c                          */
#include <libpq-fe.h>
#include "pg-utils.h"

int main(int argc, char **argv)
{
    PGresult *res;
    ExecStatusType status;
    PGconn *conn = pgconnect(argc, argv);
    if (conn == NULL) {
        return 1;
    }
    printf("Conection OK\n");

    /* INSERT INTO CONFIG */
    const char *values[] = { "1", "0.0" };
    res = PQexecParams(conn,
               "INSERT INTO config(id, major, minor) VALUES(DEFAULT, $1, $2) RETURNING id",
               2, NULL, values, NULL, NULL, 0);
    status = printStatus(res);
    printf("PQcmdStatus = %s\n", PQcmdStatus(res));
    printf("PQcmdTuples = %s\n", PQcmdTuples(res));
    char *id = NULL;
    if (status == PGRES_TUPLES_OK) {
        id = PQgetvalue(res, 0, 0);
        printf("ID = %s\n", id);
    }
    PQclear(res);
    /* neco je spatne */
    if (id == NULL) {
        PQfinish(conn);
        return 1;
    }

    printf("***\n");

    /* INSERT INTO DATABASES */
#define DB_PARAMS 8
    const char *dbvalues[][DB_PARAMS] = {
        {id, "mysql", "true", "petr", "*****", "test", "localhost", NULL},
        {id, "postgres", "false", "pavel", NULL, "petr", "localhost", NULL},
    };
    int i = 0;
    for (i = 0; i < 2; i++) {
        res = PQexecParams(conn,
                   "INSERT INTO databases VALUES(DEFAULT, $1, $2, $3, $4, $5, $6, $7, $8)",
                   DB_PARAMS, NULL, dbvalues[i], NULL, NULL, 0);
        status = printStatus(res);
        printf("PQcmdStatus = %s\n", PQcmdStatus(res));
        printf("PQcmdTuples = %s\n", PQcmdTuples(res));
        PQclear(res);
    }

    PQfinish(conn);
    return 0;
}

/*------------------------------------------------*/
