/*------------------------------------------------*/
/* 43internetFunkce/hostname.c                    */
#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "print-hostent.h"

static void usage()
{
    printf("USAGE: ./hostent server_name\n");
}

int main(int argc, char *argv[])
{
    struct hostent *server;
    struct in_addr addr;

    if (argc < 2) {
        usage();
        return 1;
    }

    server = gethostbyname(argv[1]);
    if (!server) {
        printf("Server %s nebyl nalezen\n", argv[1]);
        return 1;
    }
    printf("gethostbyname(%s):\n", argv[1]);
    printf("****************************\n");
    printHostent(server);
    memset(&addr, 0, sizeof(addr));
    memcpy(&(addr.s_addr), server->h_addr_list[0], sizeof(addr.s_addr));
    server = gethostbyaddr(&addr, 4, AF_INET);

    if (!server) {
        printf("Server %u nebyl nalezen\n", ntohl(addr.s_addr));
        return 1;
    }
    printf("\ngethostbyaddr(%u,4, AF_INET):\n", ntohl(addr.s_addr));
    printf("****************************\n");
    printHostent(server);

    printf("\n****************************\n");
    printf("inet_ntoa(%u) = %s\n", ntohl(addr.s_addr), inet_ntoa(addr));

    return 0;
}
/*------------------------------------------------*/
