/*------------------------------------------------*/
/* 50terminal/termios.c                           */
#include <termios.h>
#include <errno.h>
#include <stdlib.h>
#include <stdio.h>

static struct termios oldone;

static void obnovTerminal()
{
    printf("Obnovuji nastavení terminálu\n");
    tcsetattr(fileno(stdin), TCSANOW, &oldone);
}

int main(void)
{
    char ch;
    struct termios newone;

    tcgetattr(fileno(stdin), &oldone);
    /* pozor, c_cc pro kanonicky a nekanonicky rezim se muzou lisit,
     * znamenaji pro kazdy rezim neco trochu jineho,
     * nemeli by se zamenovat */
    newone = oldone;
    newone.c_lflag &= ~ECHO;
    newone.c_lflag &= ~ISIG;
    newone.c_lflag &= ~ICANON;
    newone.c_cc[VMIN] = 1;
    newone.c_cc[VTIME] = 0;
    if (tcsetattr(fileno(stdin), TCSAFLUSH, &newone) != 0) {
        perror("tcsetattr");
        return EXIT_FAILURE;
    }
    /* nezapomenout na obnoveni nastaveni terminalu! */
    atexit(obnovTerminal);

    printf("Zadávání znaků ukončíte klávesou Enter:\n");
    do {
        ch = getchar();
        printf("ch = %c\n", ch);
    } while (ch != '\0' && ch != '\n');

    return EXIT_SUCCESS;
}

/*------------------------------------------------*/
