/*------------------------------------------------*/
/* 51ncurses/attrs.c                              */
#include <stdio.h>
#include <ncurses.h>
#include <locale.h>
#include <stdlib.h>
#include <unistd.h>

static void obnovTerminal()
{
    printw("Obnovuji nastavení terminálu\n");
    endwin();
}

static void initNcurses() {
    setlocale(LC_ALL, "");
    initscr();
    noecho();
    raw();
    if (!has_colors()) {
        endwin();
        fprintf(stderr, "Terminál nepodporuje barvy\n");
        exit(EXIT_FAILURE);
    }
    if (start_color() != OK) {
        endwin();
        fprintf(stderr, "Nepodařilo se inicializovat barvy\n");
        exit(EXIT_FAILURE);
    }
    atexit(obnovTerminal);
}

int main(void)
{
    int l, c;
    int color_pair = 1;

    initNcurses();

    /* nastaveni barvy pozadi a prekresleni celeho okna */
    init_pair(color_pair, COLOR_RED, COLOR_YELLOW);
    attrset(COLOR_PAIR(color_pair));
    assume_default_colors(COLOR_RED, COLOR_YELLOW);
    erase();

    /* vypis zkusebnich textu */
    l = LINES / 2 - 3;
    c = COLS / 2 - 13;

    attron(A_BOLD);
    mvprintw(l++, c, "Zkušební text A_BOLD");
    attroff(A_BOLD);

    attron(A_BLINK);
    mvprintw(l++, c, "Zkušební text A_BLINK");
    attroff(A_BLINK);

    attron(A_DIM);
    mvprintw(l++, c, "Zkušební text A_DIM");
    attroff(A_DIM);

    attron(A_REVERSE);
    mvprintw(l++, c, "Zkušební text A_REVERSE");
    attroff(A_REVERSE);

    attron(A_UNDERLINE);
    mvprintw(l++, c, "Zkušební text A_UNDERLINE");
    attroff(A_UNDERLINE);

    l++;
    mvprintw(l++, c - 5, "Pokračujte stiskem libovolné klávesy ...");
    refresh();
    (void)getch();

    return 0;
}

/*------------------------------------------------*/
