/*------------------------------------------------*/
/* 51ncurses/colors.c                             */
#include <stdio.h>
#include <ncurses.h>
#include <locale.h>
#include <stdlib.h>
#include <unistd.h>

#define C_LEN 8

static void obnovTerminal()
{
    printw("Obnovuji nastavení terminálu\n");
    endwin();
}

static void initNcurses() {
    setlocale(LC_ALL, "");
    initscr();
    noecho();
    raw();
    atexit(obnovTerminal);

    if (!has_colors()) {
        fprintf(stderr, "Terminál nepodporuje barvy\n");
        exit(EXIT_FAILURE);
    }
    if (start_color() != OK) {
        fprintf(stderr, "Nepodařilo se inicializovat barvy\n");
        exit(EXIT_FAILURE);
    }
}

int main(void)
{
    int colors[C_LEN] = {
        COLOR_BLACK,
        COLOR_RED,
        COLOR_GREEN,
        COLOR_YELLOW,
        COLOR_BLUE,
        COLOR_MAGENTA,
        COLOR_CYAN,
        COLOR_WHITE
    };
    int i, j, pair;

    initNcurses();

    printw("Max počet barev = %i\n", COLORS);    //8
    printw("Max počet barevných párů = %i\n", COLOR_PAIR);    //64
    printw("Sloupců  x Řádků = %i x %i\n", COLS, LINES);

    pair = 1;
    for (i = 0; i < C_LEN; i++) {
        for (j = 0; j < C_LEN; j++) {
            init_pair(pair, colors[i], colors[j]);
            attroff(A_BOLD);
            attrset(COLOR_PAIR(pair));
            mvprintw(i * 2 + 4, j * 12, "normal %i/%i", colors[i],
                 colors[j]);
            attrset(COLOR_PAIR(pair) | A_BOLD);
            mvprintw(i * 2 + 5, j * 12, "bold %i/%i", colors[i],
                 colors[j]);
            refresh();
            usleep(1000 * 250);
            pair++;
        }
    }

    use_default_colors();
    init_pair(pair, -1, -1);    // default colors
    attroff(A_BOLD);
    attrset(COLOR_PAIR(pair));
    printw("\n\nPokračujte stiskem libovolné klávesy ...");
    refresh();
    (void)getch();
    return 0;
}

/*------------------------------------------------*/
